<?php
/**
* @version $Id: admin.installer.php,v 1.16 2004/09/06 03:58:07 eddieajau Exp $
* @package Mambo_4.5.1
* @copyright (C) 2000 - 2004 Miro International Pty Ltd
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Mambo is Free Software
* @subpackage Installer
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

// XML library
require_once( $mosConfig_absolute_path . '/includes/domit/xml_domit_lite_include.php' );
require_once( $mainframe->getPath( 'admin_html' ) );
require_once( $mainframe->getPath( 'class' ) );

// Correct mask
@umask(0);

$task = mosGetParam( $_REQUEST, 'task', '' );
$element = mosGetParam( $_REQUEST, 'element', '' );
$client = mosGetParam( $_REQUEST, 'client', '' );
$path = $mosConfig_absolute_path . "/administrator/components/com_installer/$element/$element.php";

// ensure user has access to this function
if ( !$acl->acl_check( 'administration', 'install', 'users', $my->usertype, $element . 's', 'all' ) ) {
	mosRedirect( 'index2.php', _NOT_AUTH );
}

// map the element to the required derived class
$classMap = array(
    'component' => 'mosInstallerComponent',
    'language' => 'mosInstallerLanguage',
    'mambot' => 'mosInstallerMambot',
    'module' => 'mosInstallerModule',
    'template' => 'mosInstallerTemplate'
);

if (array_key_exists ( $element, $classMap )) {
	require_once( $mainframe->getPath( 'installer_class', $element ) );

	switch ($task) {

		case 'uploadfile':
		    uploadPackage( $classMap[$element], $option, $element, $client );
			break;

		case 'installfromdir':
			installFromDirectory( $classMap[$element], $option, $element, $client );
			break;

		case 'remove':
		    removeElement( $classMap[$element], $option, $element, $client );
			break;

		default:
			$path = $mosConfig_absolute_path . "/administrator/components/com_installer/$element/$element.php";

			if (file_exists( $path )) {
				require $path;
			} else {
				echo (_GL_MSG_INSTALL_NOT_FOUND_ELEMENT);
			}
		    break;
	}
} else {
	echo (_GL_MSG_INSTALL_NOT_AVAILABLE_ELEMENT);
}

/**
* @param string The class name for the installer
* @param string The URL option
* @param string The element name
*/
function uploadPackage( $installerClass, $option, $element, $client ) {
	global $mainframe;

	$installer = new $installerClass();

	// Check if file uploads are enabled
	if (!(bool)ini_get('file_uploads')) {
		HTML_installer::showInstallMessage( (_GL_MSG_INSTALL_UPLOAD_ENABLED),
			(_GL_MSG_INSTALL_ERR), $installer->returnTo( $option, $element, $client ) );
		exit();
	}

	// Check that the zlib is available
	if(!extension_loaded('zlib')) {
		HTML_installer::showInstallMessage( (_GL_MSG_INSTALL_ZLIB),
			(_GL_MSG_INSTALL_ERR), $installer->returnTo( $option, $element, $client ) );
		exit();
	}

	$userfile = mosGetParam( $_FILES, 'userfile', null );

	if (!$userfile) {
		HTML_installer::showInstallMessage( (_GL_MSG_INSTALL_NO_FILE_SELECTED), (_GL_MSG_INSTALL_UPLOAD_NEW_MODULE_ERR),
			$installer->returnTo( $option, $element, $client ));
		exit();
	}

	$userfile_name = $userfile['name'];

	$msg = '';
	$resultdir = uploadFile( $userfile['tmp_name'], $userfile['name'], $msg );

	if ($resultdir !== false) {
		if (!$installer->upload( $userfile['name'] )) {
			HTML_installer::showInstallMessage( $installer->getError(), (_GL_INSTALL_UPLOAD).$element.(_GL_MSG_INSTALL_UPLOAD_FAILED),
				$installer->returnTo( $option, $element, $client ) );
		}
		$ret = $installer->install();

		HTML_installer::showInstallMessage( $installer->getError(), (_GL_INSTALL_UPLOAD).$element.' - '.($ret ? (_GL_SUCCES) : (_GL_MSG_INSTALL_UPLOAD_FAILED)),
			$installer->returnTo( $option, $element, $client ) );
		cleanupInstall( $userfile['name'], $installer->unpackDir() );
	} else {
		HTML_installer::showInstallMessage( $msg, (_GL_INSTALL_UPLOAD).$element.(_GL_MSG_INSTALL_UPLOAD_ERR),
			$installer->returnTo( $option, $element, $client ) );
	}
}

/**
* Install a template from a directory
* @param string The URL option
*/
function installFromDirectory( $installerClass, $option, $element, $client ) {
	$userfile = mosGetParam( $_REQUEST, 'userfile', '' );

	if (!$userfile) {
		mosRedirect( "index2.php?option=$option&element=module", (_GL_MSG_SEL_DIRECTORY) );
	}

	$installer = new $installerClass();

	$path = mosPathName( $userfile );
	if (!is_dir( $path )) {
		$path = dirname( $path );
	}

	$ret = $installer->install( $path );
	HTML_installer::showInstallMessage( $installer->getError(), (_GL_MSG_INSTALL_UPLOAD_NEW).$element.' - '.($ret ? _GL_SUCCES : (_GL_INSTALL_ERROR)),
		$installer->returnTo( $option, $element, $client ) );
}
/**
* 
* @param 
*/
function removeElement( $installerClass, $option, $element, $client ) {
	$cid = mosGetParam( $_REQUEST, 'cid', array(0) );
	if (!is_array( $cid )) {
	    $cid = array(0);
	}

	$installer = new $installerClass();
	$result = false;
	if ($cid[0]) {
	    $result = $installer->uninstall( $cid[0], $option, $client );
	}
	
	$msg = $installer->getError();

	mosRedirect( $installer->returnTo( $option, $element, $client ), $result ? (_GL_SUCCES) . $msg : (_GL_FAILED) . $msg );
}
/**
* @param string An existing base path
* @param string A path to create from the base path
* @param int Directory permissions
* @return boolean True if successful
*/
function mosMakePath( $base, $path='', $mode=0777 ) {
	// check if dir exists
	if (file_exists( $base . $path )) {
	    return true;
	}
	$path = str_replace( '\\', '/', $path );
	$path = str_replace( '//', '/', $path );
	$parts = explode( '/', $path );
	
	$n = count( $parts );
	if ($n < 1) {
	    return mkdir( $base, $mode );
	} else {
		$path = $base;
		for ($i = 0; $i < $n; $i++) {
		    $path .= $parts[$i] . '/';
		    if (!file_exists( $path )) {
		        if (!mkdir( $path, $mode )) {
		            return false;
				}
			}
		}
		return true;
	}
}
/**
* @param string The name of the php (temporary) uploaded file
* @param string The name of the file to put in the temp directory
* @param string The message to return
*/
function uploadFile( $filename, $userfile_name, &$msg ) {
	global $mosConfig_absolute_path;
	$baseDir = mosPathName( $mosConfig_absolute_path . '/media' );

	if (file_exists( $baseDir )) {
		if (is_writable( $baseDir )) {
			if (move_uploaded_file( $filename, $baseDir . $userfile_name )) {
			    if (chmod( $baseDir . $userfile_name, 0777 )) {
			        return true;
				} else {
					$msg = (_GL_MSG_INSTALL_FAILED_PERM);
				}
			} else {
				$msg = (_GL_MSG_INSTALL_FAILED_MOVE);
			}
		} else {
		    $msg = (_GL_MSG_INSTALL_FAILED_DIR_MEDIA_UNWRITEABLE);
		}
	} else {
	    $msg = _GL_MSG_INSTALL_FAILED_DIR_MEDIA_NOT_EXIST;
	}
	return false;
}
?>