<?php
/**
* @version $Id: rte.php,v 1.6 2004/09/08 21:53:10 ronbakker Exp $
* @package Mambo_4.5.1
* @copyright (C) 2000 - 2004 Miro International Pty Ltd
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Mambo is Free Software
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$_MAMBOTS->registerFunction( 'onInitEditor', 'botRteEditorInit' );
$_MAMBOTS->registerFunction( 'onGetEditorContents', 'botRteEditorGetContents' );
$_MAMBOTS->registerFunction( 'onEditorArea', 'botRteEditorEditorArea' );

/**
* RTE WYSIWYG Editor - javascript initialisation
*/
function botRteEditorInit() {
	global $mosConfig_live_site;
	return <<<EOD
<script language="JavaScript" type="text/javascript" src="$mosConfig_live_site/mambots/editors/rte/richtext.js"></script>
<script language="JavaScript" type="text/javascript">
<!--
/**
* Wrapper around the editor specific update function in JavaScript
*/
function updateEditorContents( editorName, newValue ) {
	enableDesignMode(editorName, newValue, false);
}
//-->
</script>
EOD;
}
/**
* RTE WYSIWYG Editor - copy editor contents to form field
* @param string The name of the editor area
* @param string The name of the form field
*/
function botRteEditorGetContents( $editorArea, $hiddenField ) {
	return <<<EOD
	updateRTE('$hiddenField');

EOD;
}
/**
* RTE WYSIWYG Editor - display the editor
* @param string The name of the editor area
* @param string The content of the field
* @param string The name of the form field
* @param string The width of the editor area
* @param string The height of the editor area
* @param int The number of columns for the editor area
* @param int The number of rows for the editor area
*/
function botRteEditorEditorArea( $name, $content, $hiddenField, $width, $height, $col, $row ) {
	global $mosConfig_live_site;
	$content = RTESafe($content);
	$content = str_replace("&lt;", "<", $content);
	$content = str_replace("&gt;", ">", $content);
	$content = str_replace("&amp;", "&", $content);
	$content = str_replace("&nbsp;", " ", $content);
	$content = str_replace("&quot;", "\"", $content);
	$content = str_replace("\\", "&#92;", $content);

	return <<<EOD
<script language="JavaScript" type="text/javascript">
<!--

//Usage: initRTE(imagesPath, includesPath, cssFile)
initRTE( '$mosConfig_live_site/mambots/editors/rte/images/', '$mosConfig_live_site/mambots/editors/rte/', '' );

//Usage: writeRichText(fieldname, html, width, height, buttons)
writeRichText('$hiddenField', '$content', $width, $height, true, false );
//-->
</script>
EOD;
}

// custom function for RTE
function RTESafe($strText) {
	//returns safe code for preloading in the RTE
	$tmpString = trim($strText);

	//convert all types of single quotes
	$tmpString = str_replace(chr(145), chr(39), $tmpString);
	$tmpString = str_replace(chr(146), chr(39), $tmpString);
	$tmpString = str_replace("'", "&#39;", $tmpString);

	//convert all types of double quotes
	$tmpString = str_replace(chr(147), chr(34), $tmpString);
	$tmpString = str_replace(chr(148), chr(34), $tmpString);
	//	$tmpString = str_replace("\"", "\"", $tmpString);

	//replace carriage returns & line feeds
	$tmpString = str_replace(chr(10), " ", $tmpString);
	$tmpString = str_replace(chr(13), " ", $tmpString);

	$tmpString = str_replace("<", "&lt;", $tmpString);
	$tmpString = str_replace(">", "&gt;", $tmpString);

	return $tmpString;
}
?>